  module cross_mod
  implicit none
  integer, parameter :: gl = 80
  character, parameter :: in_rootname*20 = '../data_set/jan_LAT_'   
  character, parameter :: out_rootname*20 = '../data_res/jan_LAT_'   
  character, parameter :: i_n1_filename*80='10GeV_clean_deg.dat', i_n2_filename*80='20GeV_clean_deg.dat'
  character, parameter :: i_n3_filename*80='30GeV_clean_deg.dat', i_n4_filename*80='40GeV_clean_deg.dat'
  character, parameter :: i_n5_filename*80='50GeV_clean_deg.dat'
  real(8),parameter :: const_pi = 3.14159265359
  real(8),parameter :: glat_max=90.d0/180.d0*const_pi, glat_min=DBLE(gl)/180.d0*const_pi
  character :: output_filename*80, output_filename_N*80, output_filename_S*80
  integer, parameter :: max_Rw = 20
  contains

  subroutine cross
  implicit none
  integer :: data_n1n, data_n1s, data_n2n, data_n2s, data_n3n, data_n3s
  integer :: data_n4n, data_n4s, data_n5n, data_n5s
  real(8), dimension(:,:), allocatable :: n1n_list, n1s_list
  real(8), dimension(:,:), allocatable :: n2n_list, n2s_list
  real(8), dimension(:,:), allocatable :: n3n_list, n3s_list
  real(8), dimension(:,:), allocatable :: n4n_list, n4s_list
  real(8), dimension(:,:), allocatable :: n5n_list, n5s_list
  character :: n1_filename*80, n2_filename*80, n3_filename*80, n4_filename*80, n5_filename*80 
  real(8), dimension(:,:), allocatable :: n1_list, n2_list, n3_list, n4_list, n5_list
  integer :: data_n1, data_n2, data_n3, data_n4, data_n5
  integer :: i, j, k, l, m
  real(8), dimension(5) :: n1, n2, n3, n4, n5
  integer :: cn1, cn2, cn3, cn4, deg
  real(8) :: Rw
  real(8), dimension(6, 5) :: nn
  real(8), dimension(6) :: dsum, sums

  n1_filename = in_rootname//i_n1_filename
  n2_filename = in_rootname//i_n2_filename
  n3_filename = in_rootname//i_n3_filename
  n4_filename = in_rootname//i_n4_filename
  n5_filename = in_rootname//i_n5_filename
  call read_data_num_NS(data_n1n, data_n1s, n1_filename)
  call read_data_num_NS(data_n2n, data_n2s, n2_filename)
  call read_data_num_NS(data_n3n, data_n3s, n3_filename)
  call read_data_num_NS(data_n4n, data_n4s, n4_filename)
  call read_data_num_NS(data_n5n, data_n5s, n5_filename)
  allocate(n1n_list(2,data_n1n))
  allocate(n1s_list(2,data_n1s))
  allocate(n2n_list(2,data_n2n))
  allocate(n2s_list(2,data_n2s))
  allocate(n3n_list(2,data_n3n))
  allocate(n3s_list(2,data_n3s))
  allocate(n4n_list(2,data_n4n))
  allocate(n4s_list(2,data_n4s))
  allocate(n5n_list(2,data_n5n))
  allocate(n5s_list(2,data_n5s))
  call read_data_NS(n1n_list, n1s_list, n1_filename)
  call read_data_NS(n2n_list, n2s_list, n2_filename)
  call read_data_NS(n3n_list, n3s_list, n3_filename)
  call read_data_NS(n4n_list, n4s_list, n4_filename)
  call read_data_NS(n5n_list, n5s_list, n5_filename)

  do k= 1, max_Rw
  deg = k
  Rw = DBLE(deg)/180.*const_pi
  write (output_filename, '(i2.2,"_",i3.3, "_clean_deg.dat")') gl, deg
  write (output_filename_N, '(i2.2,"_","n_", i3.3, "_clean_deg.dat")') gl, deg
  write (output_filename_S, '(i2.2,"_","s_", i3.3, "_clean_deg.dat")') gl, deg
  output_filename = out_rootname//output_filename
  output_filename_N = out_rootname//output_filename_N
  output_filename_S = out_rootname//output_filename_S
  open(10000,file=output_filename,status='replace')
  open(20000,file=output_filename_N,status='replace')
  open(30000,file=output_filename_S,status='replace')

  Do l=1,2
  if (l == 1) then
  call read_list_num(data_n1, n1n_list, RW)
  call read_list_num(data_n2, n2n_list, RW)
  call read_list_num(data_n3, n3n_list, RW)
  call read_list_num(data_n4, n4n_list, RW)
  call read_list_num(data_n5, n5n_list, 0.d0)
  allocate(n1_list(5,data_n1))
  allocate(n2_list(5,data_n2))
  allocate(n3_list(5,data_n3))
  allocate(n4_list(5,data_n4))
  allocate(n5_list(5,data_n5))
  call read_list(n1_list, n1n_list, RW)
  call read_list(n2_list, n2n_list, RW)
  call read_list(n3_list, n3n_list, RW)
  call read_list(n4_list, n4n_list, RW)
  call read_list(n5_list, n5n_list, 0.d0)
  else
  call read_list_num(data_n1, n1s_list, RW)
  call read_list_num(data_n2, n2s_list, RW)
  call read_list_num(data_n3, n3s_list, RW)
  call read_list_num(data_n4, n4s_list, RW)
  call read_list_num(data_n5, n5s_list, 0.d0)
  allocate(n1_list(5,data_n1))
  allocate(n2_list(5,data_n2))
  allocate(n3_list(5,data_n3))
  allocate(n4_list(5,data_n4))
  allocate(n5_list(5,data_n5))
  call read_list(n1_list, n1s_list, RW)
  call read_list(n2_list, n2s_list, RW)
  call read_list(n3_list, n3s_list, RW)
  call read_list(n4_list, n4s_list, RW)
  call read_list(n5_list, n5s_list, 0.d0)
  end if

  sums = 0.d0
  do i=1, data_n5

  n5(1)=n5_list(1,i)
  n5(2)=n5_list(2,i)
  n5(3)=n5_list(3,i)
  n5(4)=n5_list(4,i)
  n5(5)=n5_list(5,i)
  
  call sum_vec(n1, n5, Rw, n1_list, cn1)
  call sum_vec(n2, n5, Rw, n2_list, cn2)
  call sum_vec(n3, n5, Rw, n3_list, cn3)
  call sum_vec(n4, n5, Rw, n4_list, cn4)
  
  nn(1,1) = n1(2)*n2(3) - n1(3)*n2(2)
  nn(1,2) = n1(3)*n2(1) - n1(1)*n2(3)  
  nn(1,3) = n1(1)*n2(2) - n1(2)*n2(1)

  nn(2,1) = n1(2)*n3(3) - n1(3)*n3(2)
  nn(2,2) = n1(3)*n3(1) - n1(1)*n3(3)  
  nn(2,3) = n1(1)*n3(2) - n1(2)*n3(1)

  nn(3,1) = n1(2)*n4(3) - n1(3)*n4(2)
  nn(3,2) = n1(3)*n4(1) - n1(1)*n4(3)  
  nn(3,3) = n1(1)*n4(2) - n1(2)*n4(1)

  nn(4,1) = n2(2)*n3(3) - n2(3)*n3(2)
  nn(4,2) = n2(3)*n3(1) - n2(1)*n3(3)  
  nn(4,3) = n2(1)*n3(2) - n2(2)*n3(1)

  nn(5,1) = n2(2)*n4(3) - n2(3)*n4(2)
  nn(5,2) = n2(3)*n4(1) - n2(1)*n4(3)  
  nn(5,3) = n2(1)*n4(2) - n2(2)*n4(1)

  nn(6,1) = n3(2)*n4(3) - n3(3)*n4(2)
  nn(6,2) = n3(3)*n4(1) - n3(1)*n4(3)  
  nn(6,3) = n3(1)*n4(2) - n3(2)*n4(1)

  do m=1,6
  dsum(m) = n5(1)*nn(m,1) + n5(2)*nn(m,2) + n5(3)*nn(m,3)
  sums(m) = sums(m) + dsum(m)
  end do !m

  write(10000,'(6E15.5)') dsum(1:6)

  if (l ==1) then
  write(20000,'(6E15.5)') dsum(1:6)
  else
  write(30000,'(6E15.5)') dsum(1:6)
  end if

  end do !i

  deallocate(n1_list)
  deallocate(n2_list)
  deallocate(n3_list)
  deallocate(n4_list)
  deallocate(n5_list)

  end do !l
  close(10000)
  close(20000)
  close(30000)
  
  end do !k

  end subroutine

  recursive function kaijo(x) result(res)
  implicit none
  integer :: x
  real(8) ::res
  if(x<=1.0)then
    res=1.0
    else
    res=1.d0*x*kaijo(x-1)
  endif
  end function kaijo
  
  subroutine sum_vec(nn, n1, Rw, nn_list, cn)
  implicit none
  real(8) :: nn_list(:,:)
  real(8) :: Rw, Rc
  real(8), dimension(5) :: n1, n2, nn
  integer i, data_num, cn
  
  data_num = size(nn_list(1,:))

  cn=0
  nn = 0.d0
  do i = 1, data_num
  n2(1)=nn_list(1,i)
  n2(2)=nn_list(2,i)
  n2(3)=nn_list(3,i)
  n2(4)=nn_list(4,i)
  n2(5)=nn_list(5,i)

  call window_R(n1,n2,Rw,Rc)

  if (Rc > 1.d0) then
  nn(1) = nn(1) + n2(1)
  nn(2) = nn(2) + n2(2)
  nn(3) = nn(3) + n2(3)
  cn = cn +1
  end if
  end do

  IF (cn > 0) then
  nn(1) = nn(1)/DBLE(cn)
  nn(2) = nn(2)/DBLE(cn)
  nn(3) = nn(3)/DBLE(cn)
  else
  nn = 0.d0
  end if

  end subroutine



  subroutine window_R(n1, n2, Rw, Rc)
  implicit none
  real(8) :: x, y, z, d2, Rc, Rw
  real(8), dimension(5) :: n1, n2

  d2 = n1(1)*n2(1) + n1(2)*n2(2)+ n1(3)*n2(3)
!  d2 = (n1(4)-n2(4))**2 + (n1(5)-n2(5))**2
!  d2 = (n1(1)-n2(1))**2 + (n1(2)-n2(2))**2 + (n1(3)-n2(3))**2

  if (abs(d2) > cos(Rw)) then
  Rc = 10.d0
  else 
  Rc = 0.d0
  end if
  end subroutine


  subroutine read_list(out_list, data_list, Rw)
  implicit none
  integer i, j, data_num
  real(8) :: data_list(:,:), out_list(:,:)
  real(8) :: theta, phi, Rw

  i=0
  data_num = size(out_list(1,:))
  do  j=1, size(data_list(1,:))
  phi = data_list(1,j) /180.d0*const_pi
  theta = data_list(2,j) /180.d0*const_pi
  if (abs(theta) > abs(glat_min - Rw)) then
  i=i+1
  out_list(1,i) = sin(const_pi/2.-theta)*cos(phi)
  out_list(2,i) = sin(const_pi/2.-theta)*sin(phi)
  out_list(3,i) = cos(const_pi/2.-theta)
  out_list(4,i) = theta
  out_list(5,i) = phi
  if (i == data_num) exit
  end if
  end do
  close(1000)
  end subroutine


  subroutine read_list_num(data_num, data_list, Rw)
  implicit none
  integer i, j, k, data_num
  real(8) :: phi, theta, z, Rw
  real(8), dimension(:,:) :: data_list
  
  i=0
  do  j=1, size(data_list(1,:))
  phi = data_list(1,j) /180.d0*const_pi
  theta = data_list(2,j) /180.d0*const_pi
  if (abs(theta) > abs(glat_min - Rw)) i=i+1
  enddo
  data_num = i

  end subroutine


  subroutine read_data_NS(nnN_list, nnS_list, filename)
  implicit none
  integer i, j, k, io, datan_num, datas_num, datat_num
  real(8), dimension(:,:) :: nnN_list, nnS_list
  real(8) :: theta, phi
  character :: filename*80

  datan_num = size(nnN_list(1,:))
  datas_num = size(nnS_list(1,:))
  datat_num = datan_num + datas_num

  open(1000,file=filename,status='old')
  i=0
  j=0
  k=0
  do 
  read(1000,*,IOSTAT=io) phi, theta
  k=k+1
  if (theta > 0.) then
  i=i+1    
  nnN_list(1,i) = phi
  nnN_list(2,i) = theta
  else
  j=j+1
  nnS_list(1,j) = phi
  nnS_list(2,j) = theta
  end if

  if (k == datat_num) exit
  end do
  close(1000)
  end subroutine


  subroutine read_data_num_NS(datan_num, datas_num, filename)
  implicit none
  integer i, j, k, io, datan_num, datas_num
  real(8) :: phi, theta
  character :: filename*80
  
  open(1000,file=filename,status='old')
  i=0
  j=0
  k=0
  do 
  read(1000,*,IOSTAT=io) phi, theta  
  if (io .lt. 0) exit
  if (theta >0. ) then
  i=i+1
  else
  j=j+1
  end if
  k=k+1
  enddo
  datan_num = i
  datas_num = j
  close(1000)

  end subroutine

end module