(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15837,        401]
NotebookOptionsPosition[     15281,        378]
NotebookOutlinePosition[     15626,        393]
CellTagsIndexPosition[     15583,        390]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
  "CalDir", "=", 
   "\"\<C:\\\\Dropbox\\\\gamma-ray-analysis\\\\HT_codes\\\\gamma_codes\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ResDir", "=", 
   RowBox[{"CalDir", "<>", "\"\<\\\\data_res\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OutDir", "=", 
   RowBox[{"CalDir", "<>", "\"\<\\\\data_for_plot\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rootname", "=", "\"\<jan_LAT_80\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ename", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<125\>\"", ",", "\"\<135\>\"", ",", "\"\<145\>\"", ",", "\"\<235\>\"",
      ",", "\"\<245\>\"", ",", "\"\<345\>\""}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.589399673921875*^9, 3.589399758125*^9}, {
   3.58939988053125*^9, 3.589399900984375*^9}, 3.589491176421875*^9, {
   3.58951966309375*^9, 3.58951967825*^9}, {3.589785898546875*^9, 
   3.589785913703125*^9}, {3.589822843513788*^9, 3.589822851008217*^9}, 
   3.58983431375*^9, {3.59015839746875*^9, 3.590158404515625*^9}, {
   3.5901993864375*^9, 3.5901993881875*^9}, {3.590498342484375*^9, 
   3.59049834565625*^9}, {3.59088582371875*^9, 3.5908858355*^9}, {
   3.594856978828125*^9, 3.594856981359375*^9}, {3.59560416259375*^9, 
   3.595604166765625*^9}, 3.595965352328125*^9, {3.5972890452749352`*^9, 
   3.5972890488999352`*^9}, {3.5972913179936852`*^9, 
   3.5972913189468102`*^9}, {3.600295160328125*^9, 3.600295160765625*^9}, 
   3.60122740328125*^9, {3.607203493640625*^9, 3.607203495171875*^9}, {
   3.608786213875*^9, 3.6087864123125*^9}, {3.6087865466875*^9, 
   3.608786546828125*^9}, {3.608786621890625*^9, 3.608786645078125*^9}, {
   3.608842909796875*^9, 3.60884294078125*^9}, {3.609572077296875*^9, 
   3.609572087140625*^9}, {3.6095721410625*^9, 3.60957214675*^9}, 
   3.60957599084375*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rootnamen", "=", 
   RowBox[{"rootname", "<>", "\"\<_n\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rootnames", "=", 
   RowBox[{"rootname", "<>", "\"\<_s\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"degmax", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"degmin", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"StringReverse", "[", 
      RowBox[{"StringTake", "[", 
       RowBox[{
        RowBox[{"StringReverse", "[", 
         RowBox[{"\"\<000\>\"", "<>", 
          RowBox[{"ToString", "[", "jj", "]"}]}], "]"}], ",", "3"}], "]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"infile", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rootname", "<>", "\"\<_\>\"", "<>", 
      RowBox[{"num", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "<>", "\"\<_clean_deg.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"infilen", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rootnamen", "<>", "\"\<_\>\"", "<>", 
      RowBox[{"num", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "<>", "\"\<_clean_deg.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"infiles", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rootnames", "<>", "\"\<_\>\"", "<>", 
      RowBox[{"num", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "<>", "\"\<_clean_deg.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5895201290625*^9, 3.58952021640625*^9}, {
   3.58952025328125*^9, 3.589520296265625*^9}, {3.589520332921875*^9, 
   3.589520374578125*^9}, {3.5895204148125*^9, 3.589520421546875*^9}, {
   3.589522472484375*^9, 3.589522493390625*^9}, {3.589525479234375*^9, 
   3.58952547940625*^9}, {3.58962338571875*^9, 3.5896233866875*^9}, {
   3.589689234078125*^9, 3.589689234921875*^9}, {3.590158436546875*^9, 
   3.590158436953125*^9}, {3.59049842990625*^9, 3.590498446203125*^9}, {
   3.59088585209375*^9, 3.5908858655*^9}, {3.590941044984375*^9, 
   3.590941045375*^9}, {3.59339434371875*^9, 3.593394344109375*^9}, {
   3.594928359890625*^9, 3.5949283846875*^9}, {3.594928918015625*^9, 
   3.59492892696875*^9}, {3.595604221390625*^9, 3.595604222546875*^9}, 
   3.5959653855*^9, {3.5972890737905602`*^9, 3.5972890802124352`*^9}, {
   3.5972891667124352`*^9, 3.5972891714468102`*^9}, {3.608786504234375*^9, 
   3.608786516078125*^9}, {3.60878667915625*^9, 3.6087866878125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SetDirectory", "[", "ResDir", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indat", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"infile", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indatn", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"infilen", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indats", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"infiles", "[", 
       RowBox[{"[", "jj", "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{
  3.58962344846875*^9, {3.59049845440625*^9, 3.59049846590625*^9}, {
   3.594928942546875*^9, 3.594928943*^9}, {3.595604234703125*^9, 
   3.59560423625*^9}, 3.595965410703125*^9, {3.595965481390625*^9, 
   3.595965483140625*^9}, {3.5972891032905602`*^9, 3.5972891056968102`*^9}, {
   3.5972913428999352`*^9, 3.5972913445405602`*^9}, {3.600295177484375*^9, 
   3.6002951778125*^9}, 3.601227430140625*^9, {3.6072035793125*^9, 
   3.6072035805*^9}, {3.607378568421875*^9, 3.6073785686875*^9}, {
   3.607379337984375*^9, 3.6073793386875*^9}, {3.6076416003113747`*^9, 
   3.6076416014207497`*^9}, {3.60878652934375*^9, 3.6087865631875*^9}, {
   3.608786697109375*^9, 3.608786708390625*^9}}],

Cell[BoxData["\<\"C:\\\\cygwin\\\\home\\\\Hiroyuki\\\\work\\\\cr\\\\gamma\\\\\
gamma_codes\\\\data_res\"\>"], "Output",
 CellChangeTimes->{{3.594929413625*^9, 3.5949294523125*^9}, {
   3.5950190526875*^9, 3.595019100796875*^9}, {3.595604229234375*^9, 
   3.59560424315625*^9}, {3.595605260609375*^9, 3.59560527309375*^9}, {
   3.595605307046875*^9, 3.595605322*^9}, {3.59560536134375*^9, 
   3.595605386*^9}, 3.595605431640625*^9, 3.595707066703125*^9, {
   3.595707107109375*^9, 3.59570715159375*^9}, 3.5959654143125*^9, {
   3.595965470734375*^9, 3.595965512765625*^9}, {3.595965592578125*^9, 
   3.595965603390625*^9}, {3.59596629434375*^9, 3.5959663130625*^9}, {
   3.59598104059375*^9, 3.5959811254375*^9}, 3.59632055925*^9, 
   3.5972891105405602`*^9, {3.5972891913374352`*^9, 3.5972892150718102`*^9}, 
   3.5972892817124352`*^9, {3.5972893960718102`*^9, 3.5972894644155602`*^9}, {
   3.5972896508686852`*^9, 3.5972897221811852`*^9}, {3.5972913485405602`*^9, 
   3.5972914997436852`*^9}, 3.60029517825*^9, {3.600295225796875*^9, 
   3.60029525465625*^9}, {3.6002953496875*^9, 3.600295373375*^9}, 
   3.601227438140625*^9, {3.601227556421875*^9, 3.6012277029375*^9}, {
   3.607203560171875*^9, 3.6072035815625*^9}, {3.6072036493125*^9, 
   3.607203697234375*^9}, {3.60737856909375*^9, 3.607378574546875*^9}, {
   3.607378628109375*^9, 3.6073786894375*^9}, {3.60737933915625*^9, 
   3.607379393484375*^9}, {3.6076416020613747`*^9, 3.6076416731394997`*^9}, 
   3.6082629922889147`*^9, {3.6082630230076647`*^9, 3.6082630877576647`*^9}, {
   3.608786702765625*^9, 3.608786709046875*^9}, 3.60880661121875*^9, 
   3.608806777046875*^9, 3.608806993921875*^9, 3.609572163109375*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"reT", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"jj", ",", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indat", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], " ", 
          RowBox[{"10", "^", "6"}]}], " ", ",", 
         RowBox[{
          RowBox[{"StandardDeviation", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indat", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], 
          RowBox[{
           RowBox[{"10", "^", "6"}], "/", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"indat", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"reN", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"jj", ",", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indatn", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], " ", 
          RowBox[{"10", "^", "6"}]}], " ", ",", 
         RowBox[{
          RowBox[{"StandardDeviation", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indatn", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], 
          RowBox[{
           RowBox[{"10", "^", "6"}], "/", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"indatn", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"reS", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"jj", ",", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indats", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], " ", 
          RowBox[{"10", "^", "6"}]}], " ", ",", 
         RowBox[{
          RowBox[{"StandardDeviation", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"indats", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}], 
          RowBox[{
           RowBox[{"10", "^", "6"}], "/", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"indats", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"jj", ",", "degmin", ",", "degmax"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.608806682171875*^9, 3.608806714734375*^9}, {
  3.60880674740625*^9, 3.608806758875*^9}, {3.608806797390625*^9, 
  3.60880681615625*^9}, {3.6088070396875*^9, 3.608807056046875*^9}, {
  3.60880708628125*^9, 3.608807134109375*^9}, {3.60880746109375*^9, 
  3.60880749503125*^9}, {3.608807652046875*^9, 3.6088077821875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SetDirectory", "[", "OutDir", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"naT", "=", 
      RowBox[{"\"\<result_\>\"", "<>", "rootname", "<>", "\"\<_\>\"", "<>", 
       RowBox[{"Ename", "[", 
        RowBox[{"[", "ii", "]"}], "]"}], "<>", "\"\<.dat\>\""}]}], ",", 
     RowBox[{"Export", "[", 
      RowBox[{"naT", ",", 
       RowBox[{"reT", "[", 
        RowBox[{"[", "ii", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"naN", "=", 
      RowBox[{"\"\<result_\>\"", "<>", "rootnamen", "<>", "\"\<_\>\"", "<>", 
       RowBox[{"Ename", "[", 
        RowBox[{"[", "ii", "]"}], "]"}], "<>", "\"\<.dat\>\""}]}], ",", 
     RowBox[{"Export", "[", 
      RowBox[{"naN", ",", 
       RowBox[{"reN", "[", 
        RowBox[{"[", "ii", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"naS", "=", 
      RowBox[{"\"\<result_\>\"", "<>", "rootnames", "<>", "\"\<_\>\"", "<>", 
       RowBox[{"Ename", "[", 
        RowBox[{"[", "ii", "]"}], "]"}], "<>", "\"\<.dat\>\""}]}], ",", 
     RowBox[{"Export", "[", 
      RowBox[{"naS", ",", 
       RowBox[{"reS", "[", 
        RowBox[{"[", "ii", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "1", ",", "6"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.60880671990625*^9, 3.608806727453125*^9}, {
  3.60880714853125*^9, 3.608807156*^9}, {3.608807218703125*^9, 
  3.60880731146875*^9}, {3.60880736103125*^9, 3.608807372640625*^9}, {
  3.608807421265625*^9, 3.608807428609375*^9}, {3.609572217296875*^9, 
  3.609572230671875*^9}}],

Cell[BoxData["\<\"C:\\\\cygwin\\\\home\\\\Hiroyuki\\\\work\\\\cr\\\\gamma\\\\\
gamma_codes\\\\data_for_plot\"\>"], "Output",
 CellChangeTimes->{3.608807429515625*^9, 3.60880749765625*^9, 
  3.60880778559375*^9, 3.609572231953125*^9}]
}, Open  ]]
},
WindowSize->{1269, 683},
WindowMargins->{{-13, Automatic}, {Automatic, 15}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1861, 39, 155, "Input"],
Cell[2421, 61, 2899, 68, 271, "Input"],
Cell[CellGroupData[{
Cell[5345, 133, 1709, 42, 126, "Input"],
Cell[7057, 177, 1679, 23, 37, "Output"]
}, Open  ]],
Cell[8751, 203, 4339, 115, 358, "Input"],
Cell[CellGroupData[{
Cell[13115, 322, 1914, 48, 155, "Input"],
Cell[15032, 372, 233, 3, 37, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
